<?php
/*======================================================================*\
|| #################################################################### ||
|| # vBulletin 3.5.1
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2000-2005 Jelsoft Enterprises Ltd. All Rights Reserved. ||
|| # This file may not be redistributed in whole or significant part. # ||
|| #################################################################### ||
\*======================================================================*/

// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);
ignore_user_abort(true);
if (function_exists('set_time_limit') and get_cfg_var('safe_mode') == 0)
{
	@set_time_limit(1200);
}

chdir('./../');
define('CWD', (($getcwd = getcwd()) ? $getcwd : '.'));
define('DIR', CWD);

// fetch the core classes
require_once(DIR . '/includes/class_core.php');

// ##################### DEFINE IMPORTANT CONSTANTS #######################
define('THIS_SCRIPT', 'tableprefix.php');
define('NOZIP', 1);

$phrasegroups = array('maintenance');
$specialtemplates = array();

// initialize the data registry
$vbulletin =& new vB_Registry();

// parse the configuration ini file
$vbulletin->fetch_config();

require_once(DIR . "/{$vbulletin->config['Misc']['admincpdir']}/global.php");

// #############################################################################

print_cp_header($vbphrase['vbulletin_table_prefix_rename_system']);

// #############################################################################

if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'modify';
}

// #############################################################################

if ($_POST['do'] == 'rename')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'newprefix' => TYPE_STR,
		'rename' => TYPE_ARRAY,
	));

	if ($vbulletin->GPC['newprefix'] == TABLE_PREFIX)
	{
		print_cp_message("
			You have not chosen a new table prefix, this script can not continue.<br /><br />
			(Old table prefix: '<b>" . TABLE_PREFIX . "</b>', new table prefix: '<b>{$vbulletin->GPC['newprefix']}</b>')
		");
	}

	?>
	<div align="center">
	<div class="tborder" style="width:90%;">
	<div class="tcat" style="padding:4px"><b>Renaming Tables With New Table Prefix</b></div>
	<div class="alt1" style="padding:4px; text-align:<?php echo $stylevar['left']; ?>">
	<b>Please read the notes at the bottom of this page when processing is complete.</b>
	<ul class="smallfont">
	<?php

	flush();

	$valid = array();
	$tables = $db->query_write("SHOW TABLES");
	while ($table = $db->fetch_array($tables, MYSQL_NUM))
	{
		$valid["$table[0]"] = true;
	}
	unset($table);
	$db->free_result($tables);

	foreach(array_keys($vbulletin->GPC['rename']) as $table)
	{

		if (!isset($valid["$table"]))
		{
			echo "<li>Table '<i>$table</i>' does not exist!</li>\n";
			flush();
		}
		else

		{
			$name = fetch_renamed_table_name($table, TABLE_PREFIX, $vbulletin->GPC['newprefix']);
			echo "<li>Renaming <b>$name[old]</b> to <b>$name[new]</b>... ";
			flush();
			$db->query_write("ALTER TABLE $name[old] RENAME $name[new]");
			echo "Okay</li>\n";
		}

	}

	?>
	</ul>
	</div>
	<div class="tcat" style="padding:4px"><b>Renaming Process Complete</b></div>
	<div class="alt2" style="padding:4px; text-align:<?php echo $stylevar['left']; ?>">
	<p>This script has now completed.<br />
	Your table prefix has been changed from
	'<b><?php echo TABLE_PREFIX; ?></b>' to '<b><?php echo $vbulletin->GPC['newprefix']; ?></b>'.</p>
	<p>You must now edit your <i>includes/config.php</i> file to include the line:</p>
	<pre>$config['Database']['tableprefix'] = '<?php echo $vbulletin->GPC['newprefix']; ?>';</pre>
	<p><b><u>Your vBulletin installation will not function until you do this.</u></b></p>
	</div>
	</div>
	</div>
	<?php

	// this is a small hack to prevent the shutdown function from causing database errors
	$vbulletin->db->shutdownqueries = array();
	$vbulletin->session = null;

}

// #############################################################################

if ($_POST['do'] == 'confirm')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'newprefix' => TYPE_STR,
		'rename' => TYPE_ARRAY,
	));

	if (array_sum($vbulletin->GPC['rename']) == 0)
	{
		print_stop_message('sorry_no_tables_were_submitted_to_be_renamed');
	}
	else
	{
		if ($vbulletin->GPC['newprefix'] == TABLE_PREFIX)
		{
			print_cp_message("
				You have not chosen a new table prefix, this script can not continue.<br /><br />
				(Old table prefix: '<b>" . TABLE_PREFIX . "</b>', new table prefix: '<b>{$vbulletin->GPC['newprefix']}</b>')
			");
		}

		$prefixlength = strlen(TABLE_PREFIX);
		$dorename = array();
		$warn = array();
		$dotables = '';
		$warntables = '';

		print_form_header('tableprefix', 'rename');
		print_table_header("Confirm Table Prefix Change (From '" . TABLE_PREFIX . "' to '{$vbulletin->GPC['newprefix']}')");
		construct_hidden_code('newprefix', $vbulletin->GPC['newprefix']);

		foreach($vbulletin->GPC['rename'] as $table => $yesno)
		{
			if ($yesno)
			{
				construct_hidden_code("rename[$table]", 1);
				$dorename[] = $table;
				$tablename = fetch_renamed_table_name($table, TABLE_PREFIX, $vbulletin->GPC['newprefix'], true);
				$dotables .= "<tr class=\"alt2\"><td class=\"smallfont\">$tablename[old]</td><td class=\"smallfont\">$tablename[new]</td></tr>";
				if (substr($table, 0, $prefixlength) != TABLE_PREFIX)
				{
					$warn[] = $table;
				}
			}
		}

		if (!empty($warn))
		{
			foreach($warn as $table)
			{
				$warntables .= "<li>$table</li>";
			}
			print_description_row('
				<b>WARNING!</b><br />The following tables do <b>not</b> have the
				original table prefix! These tables may not be part of vBulletin.
				<ul>' . $warntables . '</ul>
				Are you <b>absolutely sure</b> you want to continue?
			');
			print_description_row('<div align="center"><input type="button" class="button" value="' . $vbphrase['go_back'] . '" onclick="history.back(1);" /></div>', 0, 2, 'tfoot');
		}
		else

		{
			$bgcounter++;
		}

		if (!empty($dorename))
		{
			print_description_row('
				<p>You have chosen to rename the following tables:</p>
				<table cellpadding="1" cellspacing="0" border="0" class="alt1" width="90%" align="center"><tr><td>
				<table cellpadding="3" cellspacing="1" border="0" width="100%">
				<tr><td><b>Original Table Name</b></td><td><b>New Table Name</b></td></tr>
				' . $dotables . '
				</table></td></tr></table>
			');
		}

		print_description_row('
			<p>If you are <b>sure</b> you want to continue and rename the tables listed
			above, click the rename button below.</p>
			<p><b>Note:</b> This is your final chance to stop. Clicking the button below will alter
			all the tables listed above, requiring you to edit your config.php file
			before your vBulletin will work again.</p>
		');

		print_submit_row($vbphrase['rename_sql_tables'], 0, 2, $vbphrase['go_back']);

	}

}

// #############################################################################

if ($_REQUEST['do'] == 'choose')
{
	print_form_header('tableprefix', 'confirm');
	print_table_header($vbphrase['rename_sql_tables']);
	print_label_row('Old Table Prefix', '<div class="bginput" style="margin-top:2px; width:230px">' . TABLE_PREFIX . '</div>');
	print_input_row('New Table Prefix', 'newprefix', TABLE_PREFIX);
	print_label_row('<b>Table Name</b>', '<input type="button" class="button" value="Set All Yes" onclick="js_check_all_option(this.form, 1);" /> <input type="button" class="button" value=" Set All No " onclick="js_check_all_option(this.form, 0);" />', 'tfoot');
	print_description_row('
		<p>Below is a list of all the tables in your database.
		You should make sure that you select <b>only</b> tables that are part of vBulletin.</p>
		<p><b>If you are not sure, do not continue with this operation.</b></p>
	');
	$prefixlength = strlen(TABLE_PREFIX);
	$tables = $db->query_write("SHOW TABLES");
	while($table = mysql_fetch_array($tables, MYSQL_NUM))
	{
		print_yes_no_row("Rename Table <b>$table[0]</b>?", "rename[$table[0]]", iif(substr($table[0], 0, $prefixlength) == TABLE_PREFIX, 1, 0));
	}
	print_submit_row('Rename Tables');

}

// #############################################################################

if ($_REQUEST['do'] == 'modify')
{

	echo '<p>&nbsp;</p><p>&nbsp;</p>';

	print_form_header('tableprefix', 'choose');
	print_table_header($vbphrase['vbulletin_table_prefix_rename_system']);
	print_description_row(construct_phrase($vbphrase['this_script_will_allow_you_to_rename_your_vb_tables'], TABLE_PREFIX));
	print_submit_row('Continue', 0);

}

// #############################################################################

print_cp_footer();

// #############################################################################

function fetch_renamed_table_name($table, $oldprefix, $newprefix, $dobold = false)
{
	static $prefixlength;

	if (!isset($prefixlength))
	{
		$prefixlength = strlen($oldprefix);
	}

	$name = array('old' => $table);

	if (substr($table, 0, $prefixlength) == $oldprefix)
	{
		$table = substr($table, $prefixlength);
		if ($dobold)
		{
			$name['old'] = "<b>$oldprefix</b>$table";
		}
	}

	$name['new'] = iif($dobold, "<b>$newprefix</b>", $newprefix) . $table;

	return $name;

}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: tableprefix.php,v $ - $Revision: 1.32 $
|| ####################################################################
\*======================================================================*/
?>